#!/bin/sh

clear && printf '\e[3J'

vbuild=`sw_vers -buildVersion`

string=`sw_vers -productVersion` 
string1=`echo ${string//[^0-9]/}`
string=${string1:0:4}

if [ "$string" != "1014" ]
        then
    printf '\n !!! This system is not Mojave!!!\n'
    printf '\nNothing changed. Exiting.....\n\n\n\n\n'
    sleep 4
#      killall Terminal
    exit 1
fi

cd $(dirname $0)


FILE="$vbuild/AppleGVA.framework/Resources/version.plist"
     if [ ! -f "$FILE" ]; then
     
     printf '\nWe has no copy system AppleGVA.framework into the script folder\n'
      printf '\nCannot continuing\n'
      printf '\nNothing changed. Exiting.....\n\n\n\n\n\n\n\n\'
      sleep 4
#      killall Terminal
      exit 1    
     fi

if  cmp -s AppleGVA_10.13.6/AppleGVA.framework/Resources/version.plist /System/Library/PrivateFrameworks/AppleGVA.framework/Resources/version.plist
     then 

      printf '\nAppleGVA.framework from 10.13.6 presenting in this system has found\n'

      else

      printf '\nAppleGVA.framework from 10.13.6 in this system has not found\n'
      printf '\nCannot continuing\n'
      printf '\nNothing changed. Exiting.....\n\n\n\n\n\n\n\n\'
      sleep 4
#      killall Terminal
      exit 1    
      
fi 
   



printf '\nEnter your password\n\n'

sudo printf '\n'
sleep 0.5

function ProgressBar {

let _progress=(${1}*100/${2}*100)/100
let _done=(${_progress}*4)/10
let _left=40-$_done

_fill=$(printf "%${_done}s")
_empty=$(printf "%${_left}s")

printf "\rProcessing: ${_fill// /.}${_empty// / } ${_progress}%%"

}


sudo rm -R -f  /System/Library/PrivateFrameworks/AppleGVA.framework

sudo cp -R $vbuild//AppleGVA.framework /System/Library/PrivateFrameworks/

sudo chmod -R 755 /System/Library/PrivateFrameworks/AppleGVA.framework

sudo chown -R 0:0 /System/Library/PrivateFrameworks/AppleGVA.framework

printf '\nRestoring done.\n'

printf '\nUpdating cache of the system frameworks.\n'



while :;do printf '.';sleep 3;done &
trap "kill $!" EXIT 
 sudo update_dyld_shared_cache -debug -force -root / 2>/dev/null
kill $!
wait $! 2>/dev/null
trap " " EXIT


printf '\nAll done\n'
sleep 1

printf '\nTimeout before reboot\n'

printf '\nPress  CTRL + C to brake and reboot later\n\n'
sleep 5


_start=1

_end=100


for number in $(seq ${_start} ${_end})
do
sleep 0.3
ProgressBar ${number} ${_end}
done

sleep 1

printf '\n\nRebooting.\n'
printf '\nit may takes a couple of minutes.\n\n'


sudo reboot now
killall Terminal
exit 1


